<?php
/**
 * @package Sj Categories Full
 * @version 2.5
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 * 
 */
defined('_JEXEC') or die;

if (!class_exists('CategoriesFullReader')){
	class CategoriesFullReader extends SjReader{
		public function getList(&$params){
			$list =array();						
			if (!isset($params['source']) || empty($params['source'])){
				$this->errors = "No selected or all selected is unpublished.";
				return array();
			}			
			 $category_ids = $this->content->getPublishedCategories($params);
			if(!empty($category_ids)) {	
				include_once JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php';			
				foreach($category_ids as $cat_ids){
					$category= $this->content->getCategory($cat_ids);
					$list[$cat_ids] = $category; 
					$slug = $category->alias ? $category->id.':'.$category->alias : $category->id;
					$category->link = JRoute::_( ContentHelperRoute::getCategoryRoute($slug) );	
				if (!isset($category->image_extracted)){
					$category_images = YTools::extractImages($category->description);
					$category->image_extracted = true;
				}							
				if (!isset($category->image)){
					foreach ($category_images as $i => $image_url) {
						if (YTools::isUrl($image_url) || file_exists($image_url)){
							$category->image = $image_url;
							break;
						}
					}
				}
				if (!isset($category->image) || (!YTools::isUrl($category->image) && !file_exists($category->image))){
					$category->image = 'modules/'.Ytools::getModule()->module . '/assets/images/nophoto.jpg';
				}																	
					$category->child = $this->itemsForCategory($category->id, $params);					
				}					
			}
  	
				return $list;
		}
	 private function itemsForCategory($category_id, $params){
		$items=array();
		if (!isset($category_id) || empty($category_id)){
			$this->errors = "No selected or all selected is unpublished.";
			return array();
		}			 
		$list_items= $this->content->getCategoryItems($category_id, $params);
		if(!empty($list_items)) {
			 $arrcustom_url=array();
			 $arrcustom_url = $this->_getCustomUrl($params['custom_url']);
			foreach($list_items as $key => $item) {																	
				if (!isset($item->image_extracted)){
					$item_images = YTools::extractImages($item->description);
					$item->image_extracted = true;
				}							
				if (!isset($item->image)){
					foreach ($item_images as $i => $image_url) {
						if (YTools::isUrl($image_url) || file_exists($image_url)){
							$item->image = $image_url;
							break;
						}
					}
				}
				if (!isset($item->image) || (!YTools::isUrl($item->image) && !file_exists($item->image))){
					$item->image = 'modules/'.Ytools::getModule()->module . '/assets/images/nophoto.jpg';
				}																
				if(array_key_exists($item->id, $arrcustom_url)){
					$item->link= $arrcustom_url[$item->id];
				}else{
					if (!isset($item->url)){
						$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->id, $item->category_id));										
					}
				}	
				if ((int)$params['item_description_keephtml'] == 0){
					$item->description = strip_tags($item->description);
				} 
					$author = &JFactory::getUser($item->author_id);							 
					$item->author = $author->get('name');
					$item->created=JHTML::_('date', $item->created, JText::_('DATE_FORMAT_LC3'));
					$item->hits=$item->hits;	
				$items[$key]=$item;		
			}									
										
		}		

		return $items;
	}
		private function _getCustomUrl($custom_url) {
			$arrUrl = array();
			$tmp = explode("\n", trim($custom_url));
			foreach( $tmp as $strTmp){
				$pos = strpos($strTmp, ":");
				if($pos >=0){
					$tmpKey = substr($strTmp, 0, $pos);
					$key = trim($tmpKey);
					$tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);
					$haveHttp =  strpos(trim($tmpLink), "http://");
					if($haveHttp<0 || ($haveHttp !== false) ){
						$link = trim($tmpLink);
					}else{
						$link = "http://" . trim($tmpLink);
					}
					$arrUrl[$key] = $link;
				}
			}
			return $arrUrl;
		}	
		
	}
}