<?php
/**
 * @package SjCore
 * @subpackage Elements
 * @version 1.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');

class JFormFieldSjContentCategories extends JFormField{

	public function getInput(){
		$html = array();
		if ($this->com_content_installed()){
			$html[] = $this->getInputHtml();			
		} else {
			$db = &JFactory::getDbo();
			$html[] = "<div style='clear:both; padding: 0 0 0 2em;'>";
			$html[] = "Cannot find table {$db->getPrefix()}categories.<br>";
			$html[] = "If you have Content component installed.<br>";
			$html[] = "Please contact us on <a href=\"http://www.smartaddons.com\" target=\"_blank\">http://www.smartaddons.com</a><br>";
			$html[] = "Thank you";
			$html[] = "</div>";
		}				
		return implode("\n", $html);
	}
	
	
	public function getInputHtml(){
		$html = array();
		$attr = $this->getFieldAttributes();

		// Get the field options.
		$db = JFactory::getDbo();
		$query="
			SELECT a.id, a.title, a.level
			FROM #__categories AS a
			WHERE a.parent_id >= 0
				AND extension = 'com_content'
				AND a.published IN (0,1)
			ORDER BY a.lft
		";
		$db->setQuery($query);
		$categories = $db->loadObjectList();	
		if (count($categories)){
			$options = array();
			foreach ($categories as $cid => $category) {
				$category_title = (($category->level) ? str_repeat('- ', $category->level-1): '') . $category->title;
				$options[] = JHtml::_('select.option', $category->id, $category_title);
			}

			// Create a read-only list (no name) with a hidden input to store the value.
			if ((string) $this->element['readonly'] == 'true') {
				$html[] = JHtml::_('select.genericlist', $options, '', trim($attr), 'value', 'text', $this->value, $this->id);
				$html[] = '<input type="hidden" name="'.$this->name.'" value="'.$this->value.'"/>';
			}
			// Create a regular list.
			else {
				$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);
			}
		} else {
			$html[] = "<div style='clear:both; padding: 0 0 0 2em;'>";
			$html[] = "Problem on reading <b>{$db->getPrefix()}categories</b><br>";
			$html[] = "Please contact us on <a href=\"http://www.smartaddons.com\" target=\"_blank\">http://www.smartaddons.com</a><br>";
			$html[] = "Thank you";
			$html[] = "</div>";
		}			
		return implode($html);
	}
	
	protected function getFieldAttributes(){
		$attr = '';
		
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="'.(string) $this->element['class'].'"' : '';
		
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->multiple ? ' multiple="multiple"' : '';
		
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		return $attr;
	}
	
	protected function com_content_installed(){
		$db = &JFactory::getDbo();
		$prefix = $db->getPrefix();
		$tables = $db->getTableList();
		return in_array($prefix.'categories', $tables);
	}
}